;	KD_FReqBase
;	Glue.asm for Manx/Lattice/etc.
;	By: Khalid Aldoseri.

;	Note:	Please use NewFReq() instead of FReq(), NewPath()
;		instead of Path() and NewPatMatch() instead of
;		PatMatch().  The old versions of the calls are here
;		for backwards compatibility only!


;Some public definitions

	SECTION	glue,CODE

	XREF	_KD_FReqBase
	XDEF	_FReq
	XDEF	_Path
	XDEF	_PatMatch
	XDEF	_NewFReq
	XDEF	_CreateFRequest
	XDEF	_DeleteFRequest
	XDEF	_NewPath
	XDEF	_NewPatMatch
	XDEF	_NextSelectEntry
	XDEF	_FlushFRBuffers

;LVO Equates

_LVOFReq		EQU	-30
_LVOPath		EQU	-36
_LVOPatMatch		EQU	-42
_LVONewFReq		EQU	-48
_LVOCreateFRequest	EQU	-54
_LVODeleteFRequest	EQU	-60
_LVONewPath		EQU	-66
_LVONewPatMatch		EQU	-72
_LVONextSelectEntry	EQU	-78
_LVOFlushFRBuffers	EQU	-84


;Glue routines

; success = NewFReq(struct FRequester *)
;   D0                     A0

_NewFReq:		move.l	_KD_FReqBase,A6
			move.l	4(sp),a0
			jmp	_LVONewFReq(A6)

; success = CreateFRequest()
;   D0

_CreateFRequest:	move.l	_KD_FReqBase,A6
			jmp	_LVOCreateFRequest(A6)

; void DeleteFRequest(struct FRequester *)
;                            A0

_DeleteFRequest:	move.l	_KD_FReqBase,A6
			move.l	4(sp),a0
			jmp	_LVODeleteFRequest(A6)

; void NewPath(filename)
;                 A0

_NewPath:		move.l	_KD_FReqBase,A6
			move.l	4(sp),a0
			jmp	_LVONewPath(A6)


; success = NewPatMatch(filename,pattern)
;   D0                     A0      A1

_NewPatMatch:		move.l	_KD_FReqBase,A6
			move.l	8(sp),a0
			move.l	4(sp),a1
			jmp	_LVONewPatMatch(A6)


; success = NextSelectEntry(struct FileRequester *)

_NextSelectEntry:	move.l	_KD_FReqBase,A6
			move.l	4(sp),a0
			jmp	_LVONextSelectEntry(A6)

; void FlushFRBuffers(struct FRequester *)
;                            A0

_FlushFRBuffers:	move.l	_KD_FReqBase,A6
			move.l	4(sp),a0
			jmp	_LVOFlushFRBuffers(A6)


;Obsolete calls!  For backwards compatibility only!

; success = FReq(screen,reqtitle,filename,directory,pattern,flags,extras)

_FReq:		move.l	_KD_FReqBase,A6
		jmp	_LVOFReq(A6)

; void Path(filename)

_Path:		move.l	_KD_FReqBase,A6
		jmp	_LVOPath(A6)

; success = PatMatch(pattern,filename)

_PatMatch:	move.l	_KD_FReqBase,A6
		jmp	_LVOPatMatch(A6)

			END

		; Copyright 1990,1991  Khalid Aldoseri.
